<?php
	##############################
	#                            #
	#   ~~Gästebuch              #
	#           Version: 4.0~~   #
	#                            #
	##############################
	
	//Name der alten DB hier eintragen
	//(Muss sich im gleichen Verzeichnis befinden, sonst anpassen!)
	//Danach das Script im Browser aufrufen (PHP Compiler (z.B. Apache - PHP) vorrausgesetzt)
	define('DB_FILE', 'test.dat');
	

	#######################
	#                     #
	#   Lizenzbedingung   #
	#                     #
	#######################
	/*
	Das Material des Gästebuchs steht unter der Creative-Commons-Lizenz Namensnennung 
	- Weitergabe unter gleichen Bedingungen 3.0 Deutschland.
	Um eine Kopie dieser Lizenz zu sehen, besuchen Sie http://creativecommons.org/licenses/by-sa/3.0/de/.
	Das ursprüngliche Werk stammt von http://suchdichsatt.de/tutorial/php-gaestebuch.
	
	Ausgenommen von dieser Lizenz ist der Captcha Ordner und die Smilies.
	Die Smilies dürfen ohne Zustimmung der Betreiber von suchdichsatt.de 
	nicht weitergegeben oder in einem anderen Script verwenden werden!
	*/
	
	/////////////////////////
	//Nichts mehr editieren//
	/////////////////////////
	ini_set('error_reporting', E_ALL | E_STRICT);
	ini_set('display_errors', true);
	header('Content-type: text/html; charset=utf-8');
	
	echo 'Lese alte Datenbank - Textdatei ' . DB_FILE . '...<br /><br />';
	
	if (!$fp = @fopen(DB_FILE, 'r')) { //Öffnen des Textfeldes/Datenbank; @ = Unterdrückung der Fehlermeldung
		echo 'Die Textdatei konnte nicht geöffnet werden! (eventuell nicht gefunden?)';
		return;
	}
	
	$output = '';
	$i = 0;
	while (!feof($fp)) { //Prüft ob der Dateizeiger am Ende der Datei angekommen ist
		$data = fgets($fp, 4096); //Liest bis zur angegebenen Länge oder einem Zeilenumbruch
		if (empty($data)) break;
		list ($date, $tag, $counter, $sender, $name, $message, $ip) = str_replace('\|', '|', preg_split('/(?<!\\\)(\|)/', $data));
		if ($i != 0)
			$output .= "\n";
		$output .= $counter . '|' . $date . '|' . $sender . '|' . $ip . '|' . $name . '|' . $message . '|';
		$i++;
	}
	fclose($fp);
	$output = str_replace("\r", '', $output);
	
	echo $i . ' Zeilen gefunden und umgewandelt.<br /><br />';
	
	$dbName = substr(DB_FILE, 0, -4) . '_new' . substr(DB_FILE, -4, 4);
	if (!$fp = @fopen($dbName, 'wb')) { //Öffnen des Textfeldes/Datenbank; @ = Unterdrückung der Fehlermeldung
		echo 'Die Textdatei konnte nicht geöffnet werden!';
		return;
	}
	$output = utf8_encode($output);
	//fwrite($fp, pack("CCC",0xef,0xbb,0xbf)); //UTF-8-DOM
	//fwrite($fp, "\xEF\xBB\xBF"); //UTF8-DOM
	fwrite($fp, $output);
	fclose($fp);
	echo 'Im Verzeichnis befindet sich nun eine Datei namens: ' . $dbName;
?>